// MediaData.h: CMediaData NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_MEDIADATA_H_)
#define _MEDIADATA_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMediaData  
{
public:
	CMediaData();
	CMediaData(const CMediaData &Operand);
	CMediaData(const DWORD dwBuffSize);
	CMediaData(const BYTE *pData, const DWORD dwDataSize);

	virtual ~CMediaData();

	CMediaData & operator = (const CMediaData &Operand);

	virtual BYTE * GetData(void) const;
	virtual const DWORD GetSize(void) const;

	virtual void SetAt(const DWORD dwPos, const BYTE byData);
	virtual const BYTE GetAt(const DWORD dwPos) const;

	virtual const DWORD SetMemory(BYTE *pData, const DWORD dwDataSize);
	virtual const DWORD SetData(const BYTE *pData, const DWORD dwDataSize);
	virtual const DWORD AddData(const BYTE *pData, const DWORD dwDataSize);
	virtual const DWORD AddData(const CMediaData *pData);
	virtual const DWORD AddByte(const BYTE byData);
	virtual const DWORD TrimHead(const DWORD dwTrimSize = 1);
	virtual const DWORD TrimTail(const DWORD dwTrimSize = 1);

	virtual const DWORD GetBuffer(const DWORD dwGetSize);
	virtual void ClearSize(void);
	virtual void Delete(void);

protected:
	DWORD m_dwDataSize;
	DWORD m_dwBuffSize;
	BYTE *m_pData;
};

#endif // !defined(_MEDIADATA_H_)
